# Unofficial community driven install methods

These are community driven alternative install methods to Windows Package Manager (WinGet) and GitHub. The PowerToys teams does not update or manage these install methods. 

These will be listed in alphabetical order.

## Chocolatey

Download and upgrade PowerToys from [Chocolatey](https://chocolatey.org). If you have any issues when installing/upgrading the package please go to the [package page](https://chocolatey.org/packages/powertoys) and follow the [Chocolatey triage process](https://chocolatey.org/docs/package-triage-process)

To install PowerToys, run the following command from the command line / PowerShell:

```powershell
choco install powertoys
```

To upgrade PowerToys, run the following command from the command line / PowerShell:

```powershell
choco upgrade powertoys
```

## Scoop

Download and update PowerToys from [Scoop](https://scoop.sh). 

To install PowerToys, run the following command from the command line / PowerShell:

```powershell
scoop install powertoys
```

To update PowerToys, run the following command from the command line / PowerShell:

```powershell
scoop update powertoys
```
